##// END OF EJS Templates
add console-setup to APT_INCLUDES for Cryptfs
Unknown -
r252:57c84b2cc324
parent child
Show More
@@ -1,663 +1,663
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 RPI3B_DTB_FILE=${RPI3B_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
49 RPI3B_DTB_FILE=${RPI3B_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
50 RPI3B_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
50 RPI3B_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
51
51
52 # Debian release
52 # Debian release
53 RELEASE=${RELEASE:=jessie}
53 RELEASE=${RELEASE:=jessie}
54 KERNEL_ARCH=${KERNEL_ARCH:=arm}
54 KERNEL_ARCH=${KERNEL_ARCH:=arm}
55 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
55 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
56 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
56 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
57 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
57 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
58 if [ "$KERNEL_ARCH" = "arm64" ] ; then
58 if [ "$KERNEL_ARCH" = "arm64" ] ; then
59 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
59 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
60 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
60 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
61 else
61 else
62 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
62 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
63 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
63 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
64 fi
64 fi
65 if [ "$RELEASE_ARCH" = "arm64" ] ; then
65 if [ "$RELEASE_ARCH" = "arm64" ] ; then
66 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
66 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
67 else
67 else
68 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
68 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
69 fi
69 fi
70 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
70 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
71
71
72 # URLs
72 # URLs
73 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
73 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
74 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
74 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
75 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
75 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
76 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
76 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
77 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
77 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
78 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
78 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
79
79
80 # Build directories
80 # Build directories
81 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
81 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
82 BUILDDIR="${BASEDIR}/build"
82 BUILDDIR="${BASEDIR}/build"
83
83
84 # Prepare date string for default image file name
84 # Prepare date string for default image file name
85 DATE="$(date +%Y-%m-%d)"
85 DATE="$(date +%Y-%m-%d)"
86 if [ -z "$KERNEL_BRANCH" ] ; then
86 if [ -z "$KERNEL_BRANCH" ] ; then
87 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
87 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
88 else
88 else
89 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
89 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
90 fi
90 fi
91
91
92 # Chroot directories
92 # Chroot directories
93 R="${BUILDDIR}/chroot"
93 R="${BUILDDIR}/chroot"
94 ETC_DIR="${R}/etc"
94 ETC_DIR="${R}/etc"
95 LIB_DIR="${R}/lib"
95 LIB_DIR="${R}/lib"
96 BOOT_DIR="${R}/boot/firmware"
96 BOOT_DIR="${R}/boot/firmware"
97 KERNEL_DIR="${R}/usr/src/linux"
97 KERNEL_DIR="${R}/usr/src/linux"
98 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
98 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
99
99
100 # Firmware directory: Blank if download from github
100 # Firmware directory: Blank if download from github
101 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
101 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
102
102
103 # General settings
103 # General settings
104 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
104 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
105 PASSWORD=${PASSWORD:=raspberry}
105 PASSWORD=${PASSWORD:=raspberry}
106 USER_PASSWORD=${USER_PASSWORD:=raspberry}
106 USER_PASSWORD=${USER_PASSWORD:=raspberry}
107 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
107 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
108 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
108 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
109 EXPANDROOT=${EXPANDROOT:=true}
109 EXPANDROOT=${EXPANDROOT:=true}
110
110
111 # Keyboard settings
111 # Keyboard settings
112 XKB_MODEL=${XKB_MODEL:=""}
112 XKB_MODEL=${XKB_MODEL:=""}
113 XKB_LAYOUT=${XKB_LAYOUT:=""}
113 XKB_LAYOUT=${XKB_LAYOUT:=""}
114 XKB_VARIANT=${XKB_VARIANT:=""}
114 XKB_VARIANT=${XKB_VARIANT:=""}
115 XKB_OPTIONS=${XKB_OPTIONS:=""}
115 XKB_OPTIONS=${XKB_OPTIONS:=""}
116
116
117 # Network settings (DHCP)
117 # Network settings (DHCP)
118 ENABLE_DHCP=${ENABLE_DHCP:=true}
118 ENABLE_DHCP=${ENABLE_DHCP:=true}
119
119
120 # Network settings (static)
120 # Network settings (static)
121 NET_ADDRESS=${NET_ADDRESS:=""}
121 NET_ADDRESS=${NET_ADDRESS:=""}
122 NET_GATEWAY=${NET_GATEWAY:=""}
122 NET_GATEWAY=${NET_GATEWAY:=""}
123 NET_DNS_1=${NET_DNS_1:=""}
123 NET_DNS_1=${NET_DNS_1:=""}
124 NET_DNS_2=${NET_DNS_2:=""}
124 NET_DNS_2=${NET_DNS_2:=""}
125 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
125 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
126 NET_NTP_1=${NET_NTP_1:=""}
126 NET_NTP_1=${NET_NTP_1:=""}
127 NET_NTP_2=${NET_NTP_2:=""}
127 NET_NTP_2=${NET_NTP_2:=""}
128
128
129 # APT settings
129 # APT settings
130 APT_PROXY=${APT_PROXY:=""}
130 APT_PROXY=${APT_PROXY:=""}
131 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
131 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
132
132
133 # Feature settings
133 # Feature settings
134 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
134 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
135 ENABLE_I2C=${ENABLE_I2C:=false}
135 ENABLE_I2C=${ENABLE_I2C:=false}
136 ENABLE_SPI=${ENABLE_SPI:=false}
136 ENABLE_SPI=${ENABLE_SPI:=false}
137 ENABLE_IPV6=${ENABLE_IPV6:=true}
137 ENABLE_IPV6=${ENABLE_IPV6:=true}
138 ENABLE_SSHD=${ENABLE_SSHD:=true}
138 ENABLE_SSHD=${ENABLE_SSHD:=true}
139 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
139 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
140 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
140 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
141 ENABLE_SOUND=${ENABLE_SOUND:=true}
141 ENABLE_SOUND=${ENABLE_SOUND:=true}
142 ENABLE_DBUS=${ENABLE_DBUS:=true}
142 ENABLE_DBUS=${ENABLE_DBUS:=true}
143 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
143 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
144 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
144 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
145 ENABLE_XORG=${ENABLE_XORG:=false}
145 ENABLE_XORG=${ENABLE_XORG:=false}
146 ENABLE_WM=${ENABLE_WM:=""}
146 ENABLE_WM=${ENABLE_WM:=""}
147 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
147 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
148 ENABLE_USER=${ENABLE_USER:=true}
148 ENABLE_USER=${ENABLE_USER:=true}
149 USER_NAME=${USER_NAME:="pi"}
149 USER_NAME=${USER_NAME:="pi"}
150 ENABLE_ROOT=${ENABLE_ROOT:=false}
150 ENABLE_ROOT=${ENABLE_ROOT:=false}
151
151
152 # SSH settings
152 # SSH settings
153 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
153 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
154 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
154 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
155 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
155 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
156 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
156 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
157 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
157 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
158
158
159 # Advanced settings
159 # Advanced settings
160 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
160 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
161 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
161 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
162 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
162 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
163 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
163 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
164 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
165 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
165 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
166 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
166 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
167 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
167 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
168 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
168 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
169 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
169 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
170 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
170 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
171 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
171 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
172
172
173 # Kernel compilation settings
173 # Kernel compilation settings
174 BUILD_KERNEL=${BUILD_KERNEL:=false}
174 BUILD_KERNEL=${BUILD_KERNEL:=false}
175 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
175 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
176 KERNEL_THREADS=${KERNEL_THREADS:=1}
176 KERNEL_THREADS=${KERNEL_THREADS:=1}
177 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
177 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
178 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
178 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
179 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
179 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
180 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
180 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
181 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
181 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
182
182
183 if [ "$KERNEL_ARCH" = "arm64" ] ; then
183 if [ "$KERNEL_ARCH" = "arm64" ] ; then
184 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
184 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
185 else
185 else
186 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
186 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
187 fi
187 fi
188
188
189 # Kernel compilation from source directory settings
189 # Kernel compilation from source directory settings
190 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
190 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
191 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
191 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
192 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
192 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
193 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
193 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
194
194
195 # Reduce disk usage settings
195 # Reduce disk usage settings
196 REDUCE_APT=${REDUCE_APT:=true}
196 REDUCE_APT=${REDUCE_APT:=true}
197 REDUCE_DOC=${REDUCE_DOC:=true}
197 REDUCE_DOC=${REDUCE_DOC:=true}
198 REDUCE_MAN=${REDUCE_MAN:=true}
198 REDUCE_MAN=${REDUCE_MAN:=true}
199 REDUCE_VIM=${REDUCE_VIM:=false}
199 REDUCE_VIM=${REDUCE_VIM:=false}
200 REDUCE_BASH=${REDUCE_BASH:=false}
200 REDUCE_BASH=${REDUCE_BASH:=false}
201 REDUCE_HWDB=${REDUCE_HWDB:=true}
201 REDUCE_HWDB=${REDUCE_HWDB:=true}
202 REDUCE_SSHD=${REDUCE_SSHD:=true}
202 REDUCE_SSHD=${REDUCE_SSHD:=true}
203 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
203 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
204
204
205 # Encrypted filesystem settings
205 # Encrypted filesystem settings
206 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
206 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
207 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
207 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
208 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
208 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
209 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
209 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
210 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
210 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
211
211
212 # Chroot scripts directory
212 # Chroot scripts directory
213 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
213 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
214
214
215 # Packages required in the chroot build environment
215 # Packages required in the chroot build environment
216 APT_INCLUDES=${APT_INCLUDES:=""}
216 APT_INCLUDES=${APT_INCLUDES:=""}
217 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
217 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
218
218
219 # Packages required for bootstrapping
219 # Packages required for bootstrapping
220 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
220 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
221 MISSING_PACKAGES=""
221 MISSING_PACKAGES=""
222
222
223 # Packages installed for c/c++ build environment in chroot (keep empty)
223 # Packages installed for c/c++ build environment in chroot (keep empty)
224 COMPILER_PACKAGES=""
224 COMPILER_PACKAGES=""
225
225
226 set +x
226 set +x
227
227
228 # Set Raspberry Pi model specific configuration
228 # Set Raspberry Pi model specific configuration
229 if [ "$RPI_MODEL" = 2 ] ; then
229 if [ "$RPI_MODEL" = 2 ] ; then
230 DTB_FILE=${RPI2_DTB_FILE}
230 DTB_FILE=${RPI2_DTB_FILE}
231 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
231 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
232 elif [ "$RPI_MODEL" = 3 ] ; then
232 elif [ "$RPI_MODEL" = 3 ] ; then
233 DTB_FILE=${RPI3_DTB_FILE}
233 DTB_FILE=${RPI3_DTB_FILE}
234 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
234 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
235 BUILD_KERNEL=true
235 BUILD_KERNEL=true
236 elif [ "$RPI_MODEL" = 3B ] ; then
236 elif [ "$RPI_MODEL" = 3B ] ; then
237 DTB_FILE=${RPI3B_DTB_FILE}
237 DTB_FILE=${RPI3B_DTB_FILE}
238 UBOOT_CONFIG=${RPI3B_UBOOT_CONFIG}
238 UBOOT_CONFIG=${RPI3B_UBOOT_CONFIG}
239 BUILD_KERNEL=true
239 BUILD_KERNEL=true
240 else
240 else
241 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
241 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
242 exit 1
242 exit 1
243 fi
243 fi
244
244
245 # Check if the internal wireless interface is supported by the RPi model
245 # Check if the internal wireless interface is supported by the RPi model
246 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
246 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
247 echo "error: The selected Raspberry Pi model has no internal wireless interface"
247 echo "error: The selected Raspberry Pi model has no internal wireless interface"
248 exit 1
248 exit 1
249 fi
249 fi
250
250
251 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
251 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
252 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
252 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
253 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
253 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
254 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
254 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
255 exit 1
255 exit 1
256 fi
256 fi
257 fi
257 fi
258
258
259 # Build RPi2/3 Linux kernel if required by Debian release
259 # Build RPi2/3 Linux kernel if required by Debian release
260 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
260 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
261 BUILD_KERNEL=true
261 BUILD_KERNEL=true
262 fi
262 fi
263
263
264 # Add packages required for kernel cross compilation
264 # Add packages required for kernel cross compilation
265 if [ "$BUILD_KERNEL" = true ] ; then
265 if [ "$BUILD_KERNEL" = true ] ; then
266 if [ "$KERNEL_ARCH" = "arm" ] ; then
266 if [ "$KERNEL_ARCH" = "arm" ] ; then
267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
268 else
268 else
269 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
269 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
270 fi
270 fi
271 fi
271 fi
272
272
273 # Add libncurses5 to enable kernel menuconfig
273 # Add libncurses5 to enable kernel menuconfig
274 if [ "$KERNEL_MENUCONFIG" = true ] ; then
274 if [ "$KERNEL_MENUCONFIG" = true ] ; then
275 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
275 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
276 fi
276 fi
277
277
278 # Add ccache compiler cache for (faster) kernel cross (re)compilation
278 # Add ccache compiler cache for (faster) kernel cross (re)compilation
279 if [ "$KERNEL_CCACHE" = true ] ; then
279 if [ "$KERNEL_CCACHE" = true ] ; then
280 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
280 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
281 fi
281 fi
282
282
283 # Add cryptsetup package to enable filesystem encryption
283 # Add cryptsetup package to enable filesystem encryption
284 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
284 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
286 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
286 APT_INCLUDES="${APT_INCLUDES},cryptsetup,console-setup"
287
287
288 if [ -z "$CRYPTFS_PASSWORD" ] ; then
288 if [ -z "$CRYPTFS_PASSWORD" ] ; then
289 echo "error: no password defined (CRYPTFS_PASSWORD)!"
289 echo "error: no password defined (CRYPTFS_PASSWORD)!"
290 exit 1
290 exit 1
291 fi
291 fi
292 ENABLE_INITRAMFS=true
292 ENABLE_INITRAMFS=true
293 fi
293 fi
294
294
295 # Add initramfs generation tools
295 # Add initramfs generation tools
296 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
296 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
297 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
297 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
298 fi
298 fi
299
299
300 # Add device-tree-compiler required for building the U-Boot bootloader
300 # Add device-tree-compiler required for building the U-Boot bootloader
301 if [ "$ENABLE_UBOOT" = true ] ; then
301 if [ "$ENABLE_UBOOT" = true ] ; then
302 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
302 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
303 fi
303 fi
304
304
305 # Check if root SSH (v2) public key file exists
305 # Check if root SSH (v2) public key file exists
306 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
306 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
307 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
307 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
308 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
308 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
309 exit 1
309 exit 1
310 fi
310 fi
311 fi
311 fi
312
312
313 # Check if $USER_NAME SSH (v2) public key file exists
313 # Check if $USER_NAME SSH (v2) public key file exists
314 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
314 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
315 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
315 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
316 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
316 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
317 exit 1
317 exit 1
318 fi
318 fi
319 fi
319 fi
320
320
321 # Check if all required packages are installed on the build system
321 # Check if all required packages are installed on the build system
322 for package in $REQUIRED_PACKAGES ; do
322 for package in $REQUIRED_PACKAGES ; do
323 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
323 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
324 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
324 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
325 fi
325 fi
326 done
326 done
327
327
328 # If there are missing packages ask confirmation for install, or exit
328 # If there are missing packages ask confirmation for install, or exit
329 if [ -n "$MISSING_PACKAGES" ] ; then
329 if [ -n "$MISSING_PACKAGES" ] ; then
330 echo "the following packages needed by this script are not installed:"
330 echo "the following packages needed by this script are not installed:"
331 echo "$MISSING_PACKAGES"
331 echo "$MISSING_PACKAGES"
332
332
333 echo -n "\ndo you want to install the missing packages right now? [y/n] "
333 echo -n "\ndo you want to install the missing packages right now? [y/n] "
334 read confirm
334 read confirm
335 [ "$confirm" != "y" ] && exit 1
335 [ "$confirm" != "y" ] && exit 1
336
336
337 # Make sure all missing required packages are installed
337 # Make sure all missing required packages are installed
338 apt-get -qq -y install ${MISSING_PACKAGES}
338 apt-get -qq -y install ${MISSING_PACKAGES}
339 fi
339 fi
340
340
341 # Check if ./bootstrap.d directory exists
341 # Check if ./bootstrap.d directory exists
342 if [ ! -d "./bootstrap.d/" ] ; then
342 if [ ! -d "./bootstrap.d/" ] ; then
343 echo "error: './bootstrap.d' required directory not found!"
343 echo "error: './bootstrap.d' required directory not found!"
344 exit 1
344 exit 1
345 fi
345 fi
346
346
347 # Check if ./files directory exists
347 # Check if ./files directory exists
348 if [ ! -d "./files/" ] ; then
348 if [ ! -d "./files/" ] ; then
349 echo "error: './files' required directory not found!"
349 echo "error: './files' required directory not found!"
350 exit 1
350 exit 1
351 fi
351 fi
352
352
353 # Check if specified KERNELSRC_DIR directory exists
353 # Check if specified KERNELSRC_DIR directory exists
354 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
354 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
355 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
355 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
356 exit 1
356 exit 1
357 fi
357 fi
358
358
359 # Check if specified UBOOTSRC_DIR directory exists
359 # Check if specified UBOOTSRC_DIR directory exists
360 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
360 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
361 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
361 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
362 exit 1
362 exit 1
363 fi
363 fi
364
364
365 # Check if specified FBTURBOSRC_DIR directory exists
365 # Check if specified FBTURBOSRC_DIR directory exists
366 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
366 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
367 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
367 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
368 exit 1
368 exit 1
369 fi
369 fi
370
370
371 # Check if specified CHROOT_SCRIPTS directory exists
371 # Check if specified CHROOT_SCRIPTS directory exists
372 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
372 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
373 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
373 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
374 exit 1
374 exit 1
375 fi
375 fi
376
376
377 # Check if specified device mapping already exists (will be used by cryptsetup)
377 # Check if specified device mapping already exists (will be used by cryptsetup)
378 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
378 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
379 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
379 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
380 exit 1
380 exit 1
381 fi
381 fi
382
382
383 # Don't clobber an old build
383 # Don't clobber an old build
384 if [ -e "$BUILDDIR" ] ; then
384 if [ -e "$BUILDDIR" ] ; then
385 echo "error: directory ${BUILDDIR} already exists, not proceeding"
385 echo "error: directory ${BUILDDIR} already exists, not proceeding"
386 exit 1
386 exit 1
387 fi
387 fi
388
388
389 # Setup chroot directory
389 # Setup chroot directory
390 mkdir -p "${R}"
390 mkdir -p "${R}"
391
391
392 # Check if build directory has enough of free disk space >512MB
392 # Check if build directory has enough of free disk space >512MB
393 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
393 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
394 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
394 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
395 exit 1
395 exit 1
396 fi
396 fi
397
397
398 set -x
398 set -x
399
399
400 # Call "cleanup" function on various signals and errors
400 # Call "cleanup" function on various signals and errors
401 trap cleanup 0 1 2 3 6
401 trap cleanup 0 1 2 3 6
402
402
403 # Add required packages for the minbase installation
403 # Add required packages for the minbase installation
404 if [ "$ENABLE_MINBASE" = true ] ; then
404 if [ "$ENABLE_MINBASE" = true ] ; then
405 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
405 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
406 fi
406 fi
407
407
408 # Add required locales packages
408 # Add required locales packages
409 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
409 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
410 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
410 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
411 fi
411 fi
412
412
413 # Add parted package, required to get partprobe utility
413 # Add parted package, required to get partprobe utility
414 if [ "$EXPANDROOT" = true ] ; then
414 if [ "$EXPANDROOT" = true ] ; then
415 APT_INCLUDES="${APT_INCLUDES},parted"
415 APT_INCLUDES="${APT_INCLUDES},parted"
416 fi
416 fi
417
417
418 # Add dbus package, recommended if using systemd
418 # Add dbus package, recommended if using systemd
419 if [ "$ENABLE_DBUS" = true ] ; then
419 if [ "$ENABLE_DBUS" = true ] ; then
420 APT_INCLUDES="${APT_INCLUDES},dbus"
420 APT_INCLUDES="${APT_INCLUDES},dbus"
421 fi
421 fi
422
422
423 # Add iptables IPv4/IPv6 package
423 # Add iptables IPv4/IPv6 package
424 if [ "$ENABLE_IPTABLES" = true ] ; then
424 if [ "$ENABLE_IPTABLES" = true ] ; then
425 APT_INCLUDES="${APT_INCLUDES},iptables"
425 APT_INCLUDES="${APT_INCLUDES},iptables"
426 fi
426 fi
427
427
428 # Add openssh server package
428 # Add openssh server package
429 if [ "$ENABLE_SSHD" = true ] ; then
429 if [ "$ENABLE_SSHD" = true ] ; then
430 APT_INCLUDES="${APT_INCLUDES},openssh-server"
430 APT_INCLUDES="${APT_INCLUDES},openssh-server"
431 fi
431 fi
432
432
433 # Add alsa-utils package
433 # Add alsa-utils package
434 if [ "$ENABLE_SOUND" = true ] ; then
434 if [ "$ENABLE_SOUND" = true ] ; then
435 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
435 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
436 fi
436 fi
437
437
438 # Add rng-tools package
438 # Add rng-tools package
439 if [ "$ENABLE_HWRANDOM" = true ] ; then
439 if [ "$ENABLE_HWRANDOM" = true ] ; then
440 APT_INCLUDES="${APT_INCLUDES},rng-tools"
440 APT_INCLUDES="${APT_INCLUDES},rng-tools"
441 fi
441 fi
442
442
443 # Add fbturbo video driver
443 # Add fbturbo video driver
444 if [ "$ENABLE_FBTURBO" = true ] ; then
444 if [ "$ENABLE_FBTURBO" = true ] ; then
445 # Enable xorg package dependencies
445 # Enable xorg package dependencies
446 ENABLE_XORG=true
446 ENABLE_XORG=true
447 fi
447 fi
448
448
449 # Add user defined window manager package
449 # Add user defined window manager package
450 if [ -n "$ENABLE_WM" ] ; then
450 if [ -n "$ENABLE_WM" ] ; then
451 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
451 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
452
452
453 # Enable xorg package dependencies
453 # Enable xorg package dependencies
454 ENABLE_XORG=true
454 ENABLE_XORG=true
455 fi
455 fi
456
456
457 # Add xorg package
457 # Add xorg package
458 if [ "$ENABLE_XORG" = true ] ; then
458 if [ "$ENABLE_XORG" = true ] ; then
459 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
459 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
460 fi
460 fi
461
461
462 # Replace selected packages with smaller clones
462 # Replace selected packages with smaller clones
463 if [ "$ENABLE_REDUCE" = true ] ; then
463 if [ "$ENABLE_REDUCE" = true ] ; then
464 # Add levee package instead of vim-tiny
464 # Add levee package instead of vim-tiny
465 if [ "$REDUCE_VIM" = true ] ; then
465 if [ "$REDUCE_VIM" = true ] ; then
466 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
466 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
467 fi
467 fi
468
468
469 # Add dropbear package instead of openssh-server
469 # Add dropbear package instead of openssh-server
470 if [ "$REDUCE_SSHD" = true ] ; then
470 if [ "$REDUCE_SSHD" = true ] ; then
471 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
471 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
472 fi
472 fi
473 fi
473 fi
474
474
475 if [ "$RELEASE" != "jessie" ] ; then
475 if [ "$RELEASE" != "jessie" ] ; then
476 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
476 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
477 fi
477 fi
478
478
479 # Configure kernel sources if no KERNELSRC_DIR
479 # Configure kernel sources if no KERNELSRC_DIR
480 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
480 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
481 KERNELSRC_CONFIG=true
481 KERNELSRC_CONFIG=true
482 fi
482 fi
483
483
484 # Configure reduced kernel
484 # Configure reduced kernel
485 if [ "$KERNEL_REDUCE" = true ] ; then
485 if [ "$KERNEL_REDUCE" = true ] ; then
486 KERNELSRC_CONFIG=false
486 KERNELSRC_CONFIG=false
487 fi
487 fi
488
488
489 # Execute bootstrap scripts
489 # Execute bootstrap scripts
490 for SCRIPT in bootstrap.d/*.sh; do
490 for SCRIPT in bootstrap.d/*.sh; do
491 head -n 3 "$SCRIPT"
491 head -n 3 "$SCRIPT"
492 . "$SCRIPT"
492 . "$SCRIPT"
493 done
493 done
494
494
495 ## Execute custom bootstrap scripts
495 ## Execute custom bootstrap scripts
496 if [ -d "custom.d" ] ; then
496 if [ -d "custom.d" ] ; then
497 for SCRIPT in custom.d/*.sh; do
497 for SCRIPT in custom.d/*.sh; do
498 . "$SCRIPT"
498 . "$SCRIPT"
499 done
499 done
500 fi
500 fi
501
501
502 # Execute custom scripts inside the chroot
502 # Execute custom scripts inside the chroot
503 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
503 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
504 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
504 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
505 chroot_exec /bin/bash -x <<'EOF'
505 chroot_exec /bin/bash -x <<'EOF'
506 for SCRIPT in /chroot_scripts/* ; do
506 for SCRIPT in /chroot_scripts/* ; do
507 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
507 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
508 $SCRIPT
508 $SCRIPT
509 fi
509 fi
510 done
510 done
511 EOF
511 EOF
512 rm -rf "${R}/chroot_scripts"
512 rm -rf "${R}/chroot_scripts"
513 fi
513 fi
514
514
515 # Remove c/c++ build environment from the chroot
515 # Remove c/c++ build environment from the chroot
516 chroot_remove_cc
516 chroot_remove_cc
517
517
518 # Remove apt-utils
518 # Remove apt-utils
519 if [ "$RELEASE" = "jessie" ] ; then
519 if [ "$RELEASE" = "jessie" ] ; then
520 chroot_exec apt-get purge -qq -y --force-yes apt-utils
520 chroot_exec apt-get purge -qq -y --force-yes apt-utils
521 fi
521 fi
522
522
523 # Generate required machine-id
523 # Generate required machine-id
524 MACHINE_ID=$(dbus-uuidgen)
524 MACHINE_ID=$(dbus-uuidgen)
525 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
525 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
526 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
526 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
527
527
528 # APT Cleanup
528 # APT Cleanup
529 chroot_exec apt-get -y clean
529 chroot_exec apt-get -y clean
530 chroot_exec apt-get -y autoclean
530 chroot_exec apt-get -y autoclean
531 chroot_exec apt-get -y autoremove
531 chroot_exec apt-get -y autoremove
532
532
533 # Unmount mounted filesystems
533 # Unmount mounted filesystems
534 umount -l "${R}/proc"
534 umount -l "${R}/proc"
535 umount -l "${R}/sys"
535 umount -l "${R}/sys"
536
536
537 # Clean up directories
537 # Clean up directories
538 rm -rf "${R}/run/*"
538 rm -rf "${R}/run/*"
539 rm -rf "${R}/tmp/*"
539 rm -rf "${R}/tmp/*"
540
540
541 # Clean up files
541 # Clean up files
542 rm -f "${ETC_DIR}/ssh/ssh_host_*"
542 rm -f "${ETC_DIR}/ssh/ssh_host_*"
543 rm -f "${ETC_DIR}/dropbear/dropbear_*"
543 rm -f "${ETC_DIR}/dropbear/dropbear_*"
544 rm -f "${ETC_DIR}/apt/sources.list.save"
544 rm -f "${ETC_DIR}/apt/sources.list.save"
545 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
545 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
546 rm -f "${ETC_DIR}/*-"
546 rm -f "${ETC_DIR}/*-"
547 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
547 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
548 rm -f "${ETC_DIR}/resolv.conf"
548 rm -f "${ETC_DIR}/resolv.conf"
549 rm -f "${R}/root/.bash_history"
549 rm -f "${R}/root/.bash_history"
550 rm -f "${R}/var/lib/urandom/random-seed"
550 rm -f "${R}/var/lib/urandom/random-seed"
551 rm -f "${R}/initrd.img"
551 rm -f "${R}/initrd.img"
552 rm -f "${R}/vmlinuz"
552 rm -f "${R}/vmlinuz"
553 rm -f "${R}${QEMU_BINARY}"
553 rm -f "${R}${QEMU_BINARY}"
554
554
555 # Calculate size of the chroot directory in KB
555 # Calculate size of the chroot directory in KB
556 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
556 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
557
557
558 # Calculate the amount of needed 512 Byte sectors
558 # Calculate the amount of needed 512 Byte sectors
559 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
559 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
560 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
560 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
561 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
561 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
562
562
563 # The root partition is EXT4
563 # The root partition is EXT4
564 # This means more space than the actual used space of the chroot is used.
564 # This means more space than the actual used space of the chroot is used.
565 # As overhead for journaling and reserved blocks 35% are added.
565 # As overhead for journaling and reserved blocks 35% are added.
566 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
566 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
567
567
568 # Calculate required image size in 512 Byte sectors
568 # Calculate required image size in 512 Byte sectors
569 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
569 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
570
570
571 # Prepare image file
571 # Prepare image file
572 if [ "$ENABLE_SPLITFS" = true ] ; then
572 if [ "$ENABLE_SPLITFS" = true ] ; then
573 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
573 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
574 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
574 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
575 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
575 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
576 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
576 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
577
577
578 # Write firmware/boot partition tables
578 # Write firmware/boot partition tables
579 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
579 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
580 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
580 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
581 EOM
581 EOM
582
582
583 # Write root partition table
583 # Write root partition table
584 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
584 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
585 ${TABLE_SECTORS},${ROOT_SECTORS},83
585 ${TABLE_SECTORS},${ROOT_SECTORS},83
586 EOM
586 EOM
587
587
588 # Setup temporary loop devices
588 # Setup temporary loop devices
589 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
589 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
590 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
590 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
591 else # ENABLE_SPLITFS=false
591 else # ENABLE_SPLITFS=false
592 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
592 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
593 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
593 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
594
594
595 # Write partition table
595 # Write partition table
596 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
596 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
597 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
597 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
598 ${ROOT_OFFSET},${ROOT_SECTORS},83
598 ${ROOT_OFFSET},${ROOT_SECTORS},83
599 EOM
599 EOM
600
600
601 # Setup temporary loop devices
601 # Setup temporary loop devices
602 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
602 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
603 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
603 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
604 fi
604 fi
605
605
606 if [ "$ENABLE_CRYPTFS" = true ] ; then
606 if [ "$ENABLE_CRYPTFS" = true ] ; then
607 # Create dummy ext4 fs
607 # Create dummy ext4 fs
608 mkfs.ext4 "$ROOT_LOOP"
608 mkfs.ext4 "$ROOT_LOOP"
609
609
610 # Setup password keyfile
610 # Setup password keyfile
611 touch .password
611 touch .password
612 chmod 600 .password
612 chmod 600 .password
613 echo -n ${CRYPTFS_PASSWORD} > .password
613 echo -n ${CRYPTFS_PASSWORD} > .password
614
614
615 # Initialize encrypted partition
615 # Initialize encrypted partition
616 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
616 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
617
617
618 # Open encrypted partition and setup mapping
618 # Open encrypted partition and setup mapping
619 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
619 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
620
620
621 # Secure delete password keyfile
621 # Secure delete password keyfile
622 shred -zu .password
622 shred -zu .password
623
623
624 # Update temporary loop device
624 # Update temporary loop device
625 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
625 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
626
626
627 # Wipe encrypted partition (encryption cipher is used for randomness)
627 # Wipe encrypted partition (encryption cipher is used for randomness)
628 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
628 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
629 fi
629 fi
630
630
631 # Build filesystems
631 # Build filesystems
632 mkfs.vfat "$FRMW_LOOP"
632 mkfs.vfat "$FRMW_LOOP"
633 mkfs.ext4 "$ROOT_LOOP"
633 mkfs.ext4 "$ROOT_LOOP"
634
634
635 # Mount the temporary loop devices
635 # Mount the temporary loop devices
636 mkdir -p "$BUILDDIR/mount"
636 mkdir -p "$BUILDDIR/mount"
637 mount "$ROOT_LOOP" "$BUILDDIR/mount"
637 mount "$ROOT_LOOP" "$BUILDDIR/mount"
638
638
639 mkdir -p "$BUILDDIR/mount/boot/firmware"
639 mkdir -p "$BUILDDIR/mount/boot/firmware"
640 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
640 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
641
641
642 # Copy all files from the chroot to the loop device mount point directory
642 # Copy all files from the chroot to the loop device mount point directory
643 rsync -a "${R}/" "$BUILDDIR/mount/"
643 rsync -a "${R}/" "$BUILDDIR/mount/"
644
644
645 # Unmount all temporary loop devices and mount points
645 # Unmount all temporary loop devices and mount points
646 cleanup
646 cleanup
647
647
648 # Create block map file(s) of image(s)
648 # Create block map file(s) of image(s)
649 if [ "$ENABLE_SPLITFS" = true ] ; then
649 if [ "$ENABLE_SPLITFS" = true ] ; then
650 # Create block map files for "bmaptool"
650 # Create block map files for "bmaptool"
651 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
651 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
652 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
652 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
653
653
654 # Image was successfully created
654 # Image was successfully created
655 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
655 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
656 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
656 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
657 else
657 else
658 # Create block map file for "bmaptool"
658 # Create block map file for "bmaptool"
659 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
659 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
660
660
661 # Image was successfully created
661 # Image was successfully created
662 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
662 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
663 fi
663 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant